;| Breaker
-------------------------------------------------------------------------------

eigener Bruchbefehl.
Vorteil gegenber Standard-Bruch: Wiederholend und ein Befehl fr beide Bruchbefehle


Revisionen
Aug. 2007 - ActiveX-Schnittstelle aktiviert, OSMODE in Schleife zurckgesetzt

-------------------------------------------------------------------------------
Copyright (C) 2006 Markus Hoffmann
www.CADmaro.de
-------------------------------------------------------------------------------
FREEWARE:
Dieser Quellcode darf unbegrenzt und fr jeden Zweck verwendet werden sofern
keine Gebhr erhoben wird. Der Quellcode darf weiterhin nach eigenen
Bedrfnissen anpasst, verbessert, kopiert und weitergegeben werden. Der
Urheberrechtshinweis darf nicht entfernt werden.
-------------------------------------------------------------------------------
|;
(defun c:Breaker (/ varlist ent pt1 point pt2)
;; Initialisierung
  (defun mx:Init ()
    (vl-load-com)
    (setq objAcDoc
           (vlax-get-property
             (vlax-get-acad-object)
             'ActiveDocument
           )
    )
    (mapcar '(lambda (arg)
               (setq
                 varlist (cons (cons (car arg) (getvar (car arg))) varlist)
               )
               (setvar (car arg)
                       (if (= 'LIST (type (setq argument (cdr arg))))
                         (eval argument)
                         argument
                       )
               )
             )
            '(("CMDECHO" . 0)
              ("PDMODE" . 3)
              ("PDSIZE" . -10)
              ("OSMODE" . (getvar "OSMODE"))
             )
    )
    (setq errorMX *error*
          *error* mx:Error
    )
    (vlax-invoke-method objAcDoc 'EndUndomark)
    (vlax-invoke-method objAcDoc 'StartUndomark)
  )
;; Zurcksetzen
  (defun mx:Reset ()
    (mapcar
      '(lambda (arg)
         (setvar (car arg) (cdr arg))
       )
      varlist
    )
    (vlax-invoke-method objAcDoc 'EndUndomark)
    (vlax-release-object objAcDoc)
    (setq *error* errorMX)
  )
;; Errorfunktion
  (defun mx:Error (s)
    (print (strcat "Fehler - " s))
;;;    (command)
;;;    (command "_.undo" "_back")
    (mx:Reset)
    (princ)
  )
  ;; Hauptprogramm
  (mx:Init)
  (while
    (setq ent (entsel "\nElement fr Bruch whlen "))
     (if
       (wcmatch
         (strcase (cdr (assoc 0 (entget (car ent)))))
         "ARC,LINE,*POLYLINE"
       )
        (progn
          (redraw (car ent) 3)
          (setvar "OSMODE" (cdar varlist))
          (initget 1)
          (setq pt1 (getpoint "\nErster Punkt:"))
          (entmake (list
                     '(0 . "POINT")
                     (cons 10 pt1)
                   )
          )
          (setq point (entlast))
          (initget 6)
          (setq
            pt2
             (getpoint
               "\nZweiter Punkt oder Rechtsklick fr ersten Punkt:"
             )
          )
          (setvar "OSMODE" 0)
          (vl-cmdf "_.break"
                   ent
                   "_f"
                   pt1
                   (if pt2
                     pt2
                     pt1
                   )
          )
          (entdel point)
        )
        (princ "\nKann Objekt nicht brechen!")
     )
  )
  (mx:Reset)
  (princ "\nFertig.")
  (princ)
)
(princ
  "\nBreaker.lsp wurde geladen. Start mit dem Befehl \"Breaker\"."
)
(princ)